<?php

namespace Ulmus\Entity\Sqlite;

use Ulmus\EntityCollection;
use Ulmus\Query\{From, Select};
use Ulmus\{Attribute\Obj\Table, Repository};
use Ulmus\Attribute\Property\{Field, Filter, FilterJoin, Relation, Join, Virtual, Where};

#[Table(name: "sqlite_master")]
class Schema
{
    use \Ulmus\EntityTrait;

    #[Field\Id]
    public ? string $name;

    #[Field]
    public ? string $type;

    #[Field(name: "tbl_name")]
    public ? string $tableName;

    #[Field]
    public ? int $rootpage;

    #[Field]
    public ? string $sql;

    ##[Relation("oneToMany", key: "tableName", foreignKey: "tableName", entity: Column::class)]
    #[Virtual(method: "filterColumns")]
    public EntityCollection $columns;

    public function filterColumns() : EntityCollection
    {
        return ( new Repository\SqliteRepository(Column::class) )->pragma('table_info', $this->tableName)->collectionFromQuery();
    }
}